#include <tchar.h>

#include <Windows.h>
#include <vector>
#include <list>
#include <algorithm>

bool		g_run=true;
LPCTSTR		window_class_name=_T("main_window");
HWND		window_main;
HWND		window_pause;
HWND		window_score;
DWORD		timet_interval_step=500;
bool		g_pause=false;
DWORD		score=0;

std::vector<POINT> draft;
std::vector<POINT> figure;
std::vector<POINT> next;

#define POINT_SIZE 10
#define BOARD_HEIGHT 20
#define BOARD_WIDTH 10
#define TIMER_ID_STEP 1
#define PATTERN_SIZE 4

#define INFO_X 110
#define INFO_Y 110
#define NEXT_X 120
#define NEXT_Y 40


#define XHNG(a,b) {int t=a; a=b; b=t;}

POINT pat1[]={
				{1,0},
				{0,0},
				{0,-1},
				{2,0},
			};

POINT pat2[]={
				{1,0},
				{0,0},
				{1,-1},
				{2,0},
			};
POINT pat3[]={
				{1,0},
				{0,0},
				{-1,0},
				{2,0},
			};

POINT pat4[]={
				{1,0},
				{0,0},
				{0,-1},
				{1,-1},
			};

POINT pat5[]={
				{1,0},
				{0,0},
				{2,0},
				{2,-1},
			};

POINT *figures[]={pat1,pat2,pat3,pat4,pat5};

int Random(int max_value)
{
	return int(double(rand())/RAND_MAX*max_value);
}

bool IsIntersectBorder(std::vector<POINT>& figure)
{
	for( size_t i=0; i<figure.size(); i++ )
	{
		if( (figure[i].x<0) || (figure[i].x>=BOARD_WIDTH) || 
			(figure[i].y<0) || (figure[i].y>=BOARD_HEIGHT) )
			return true;
	}
	return false;
}

void RotateFigure(std::vector<POINT>* figure, size_t center_index)
{
	POINT center;

	center=(*figure)[center_index];

	for( size_t i=0; i<figure->size(); i++ )
	{
		(*figure)[i].x-=center.x;
		(*figure)[i].y-=center.y;
	}

	for( size_t i=0; i<figure->size(); i++ )
	{
		(*figure)[i].x=-(*figure)[i].x;
		XHNG((*figure)[i].x,(*figure)[i].y)	
	}

	for( size_t i=0; i<figure->size(); i++ )
	{
		(*figure)[i].x+=center.x;
		(*figure)[i].y+=center.y;
	}
}

void MoveFigureDown(std::vector<POINT>* figure)
{
	for( size_t i=0; i<figure->size(); i++ )
		(*figure)[i].y-=1;
}

void MoveFigureRight(std::vector<POINT>* figure)
{
	for( size_t i=0; i<figure->size(); i++ )
		(*figure)[i].x+=1;
}

void MoveFigureLeft(std::vector<POINT>* figure)
{
	for( size_t i=0; i<figure->size(); i++ )
		(*figure)[i].x-=1;
}

bool IntersectWithDraft(POINT point)
{
	for( size_t i=0; i<draft.size(); i++ )
	{
		if( (draft[i].x==point.x) && (draft[i].y==point.y) )
			return true;
	}

	return false;
}

void DestroyDraftLine(int y)
{
	for( size_t i=0; i<draft.size(); )
	{
		if(draft[i].y==y)
		{
			draft.erase(draft.begin()+i);	
			i=0;
		}
		else
			i++;
	}

	for( size_t i=0; i<draft.size(); i++ )
	{
		if(draft[i].y>y)
			draft[i].y-=1;
	}
}

bool DraftLineContinuous(int y)
{
	DWORD count=0;
	for( size_t i=0; i<draft.size(); i++ )
	{
		if(draft[i].y==y)
			count++;
	}

	return (count>=BOARD_WIDTH);
}

void DestroyContinuousDraftLines()
{
	DWORD count=0;
	for( int i=0; i<BOARD_HEIGHT;)
	{
		if( DraftLineContinuous(i) )
		{
			DestroyDraftLine(i);
			i=0;
			count++;
		}
		else
			i++;
	}

	if(count!=0)
	{
		score+=count*100*count;
		TCHAR str[256];
		_stprintf(str,_T("score %u"),score);
		SetWindowText(window_score,str);
	}
}
bool CheckFigureRotate(size_t center_index)
{
	std::vector<POINT> f=figure;

	RotateFigure(&f,center_index);	

	for( size_t i=0; i<f.size(); i++ )
	{
		int y=f[i].y;
		int x=f[i].x;
		if( (y<0) || (x<0) || (x>=BOARD_WIDTH) )
			return false;

		if( IntersectWithDraft(f[i]) )
			return false;
	}

	return true;
}

void RotateFigureTidy()
{
	if(figure.size()>=1)
		if( CheckFigureRotate(0) )
			RotateFigure(&figure,0);	
}

bool CheckFigureMoveDown()
{
	std::vector<POINT> f=figure;

	MoveFigureDown(&f);	

	for( size_t i=0; i<f.size(); i++ )
	{
		int y=f[i].y;
		if( y<0)
			return false;

		if( IntersectWithDraft(f[i]) )
			return false;
	}

	return true;
}

bool CheckFigureMoveRight()
{
	std::vector<POINT> f=figure;

	MoveFigureRight(&f);	

	for( size_t i=0; i<f.size(); i++ )
	{
		int x=f[i].x;
		if( x>=BOARD_WIDTH)
			return false;

		if( IntersectWithDraft(f[i]) )
			return false;
	}

	return true;
}

bool CheckFigureMoveLeft()
{
	std::vector<POINT> f=figure;

	MoveFigureLeft(&f);	

	for( size_t i=0; i<f.size(); i++ )
	{
		int x=f[i].x;
		if( x<0)
			return false;

		if( IntersectWithDraft(f[i]) )
			return false;
	}

	return true;
}

void DraftingFigure()
{
	draft.insert( draft.end(), figure.begin(), figure.end() ); 
	figure.clear();
}

void DropFigure()
{
	int index=Random(sizeof(figures)/sizeof(figures[0]));

	figure=next;

	for( size_t i=0; i<figure.size(); i++ )
	{
		figure[i].x+=4;
		figure[i].y+=BOARD_HEIGHT;
	}

	next.clear();
	for( size_t i=0; i<PATTERN_SIZE; i++ )
	{
		POINT p;
		p=figures[index][i];
		next.push_back(p);
	}

	if(figure.empty())
		DropFigure();
}

void UpdateWnd()
{
	RedrawWindow(window_main,NULL,NULL,/*RDW_ERASE|*/RDW_UPDATENOW|RDW_INVALIDATE|RDW_NOCHILDREN);
}

void StepRotate()
{
	RotateFigureTidy();

	UpdateWnd();
}

void StepDown()
{
	if(CheckFigureMoveDown())
		MoveFigureDown(&figure);
	else
	{

		if(IsIntersectBorder(figure))
		{
			KillTimer(window_main,TIMER_ID_STEP);
			MessageBox(window_main, _T("GAME OVER"), _T("Tetris"), MB_OK);
			PostMessage(window_main, WM_CLOSE,NULL,NULL);
		}
		DraftingFigure();
		DropFigure();
	}

	DestroyContinuousDraftLines();
	UpdateWnd();
}

void StepRight()
{
	if(CheckFigureMoveRight())
		MoveFigureRight(&figure);

	UpdateWnd();
}

void StepLeft()
{
	if(CheckFigureMoveLeft())
		MoveFigureLeft(&figure);

	UpdateWnd();
}

VOID CALLBACK TimerStepProc(
							HWND hwnd,         // handle to window_main
							UINT uMsg,         // WM_TIMER message
							UINT_PTR idEvent,  // timer identifier
							DWORD dwTime       // current system time
							)
{
	StepDown();		
}

void SetPause()
{
	g_pause=!g_pause;
	if(g_pause)
	{
		ShowWindow(window_pause,SW_SHOW);
		::KillTimer(window_main,TIMER_ID_STEP);
	}
	else
	{
		ShowWindow(window_pause,SW_HIDE);
		::SetTimer(window_main,TIMER_ID_STEP,timet_interval_step,TimerStepProc);
	}
}

void OnKeyboard( BOOL Down,WORD repeat, WORD KeyCode, WORD ScanCode, TCHAR ch, DWORD ctrl )
{
		if(Down)
		{
			switch(KeyCode) 
			{
			case VK_ESCAPE: g_run=false; break;
			default:;
			}
		}
}

void PaintNext(HDC dc)
{
	for( size_t i=0; i<next.size(); i++ )
	{
		POINT p=next[i];
		int x1=p.x+1;
		int y1=4-p.y-1;
		int x2=x1+1;
		int y2=y1-1;

		::Rectangle(dc, x1*POINT_SIZE+NEXT_X,y1*POINT_SIZE+NEXT_Y, 
						x2*POINT_SIZE+NEXT_X,y2*POINT_SIZE+NEXT_Y);
	}
}

void PaintBricks(HDC dc, std::vector<POINT>& bricks)
{
	for( size_t i=0; i<bricks.size(); i++ )
	{
		int x1=bricks[i].x;
		int y1=BOARD_HEIGHT-bricks[i].y;
		int x2=x1+1;
		int y2=y1-1;

		::Rectangle(dc, x1*POINT_SIZE,y1*POINT_SIZE, x2*POINT_SIZE,y2*POINT_SIZE);
	}
}

void PaintObjects(HDC dc)
{
	PaintBricks(dc,draft);
	PaintBricks(dc,figure);

	POINT frame[]={ {0,0}, 
					{0, BOARD_HEIGHT*POINT_SIZE},
					{BOARD_WIDTH*POINT_SIZE, BOARD_HEIGHT*POINT_SIZE},
					{BOARD_WIDTH*POINT_SIZE, 0},
					{0, 0},
					}; 
	Polyline(dc,frame,5);
}

LRESULT CALLBACK WindowProc(HWND hw,UINT m,WPARAM wp,LPARAM lp)
{
	switch(m) 
	{
	case WM_PAINT: 
		{
			RECT		rect;

			DefWindowProc(hw,m,wp,lp);
			GetClientRect(window_main,&rect);

			HDC dc=GetDC(hw);
			HBITMAP bmp=CreateCompatibleBitmap(dc, rect.right-rect.left, rect.bottom-rect.top);
			HDC mdc=CreateCompatibleDC(dc);

			HGDIOBJ old_bmp=SelectObject(mdc,bmp);

			HBRUSH brush=GetSysColorBrush( COLOR_ACTIVEBORDER );
			HGDIOBJ old_brush=SelectObject(mdc,brush);
			BitBlt(mdc,0,0, BOARD_WIDTH*POINT_SIZE+1, BOARD_HEIGHT*POINT_SIZE+1, NULL,0,0,PATCOPY);
			BitBlt(mdc,NEXT_X,NEXT_Y, 4*POINT_SIZE, 4*POINT_SIZE, NULL,0,0,PATCOPY);
			SelectObject(mdc,old_brush);

			PaintObjects(mdc);
			PaintNext(mdc);
			BitBlt(dc,0,0, BOARD_WIDTH*POINT_SIZE+1, BOARD_HEIGHT*POINT_SIZE+1, mdc,0,0,SRCCOPY);
			BitBlt(dc,NEXT_X,NEXT_Y, 4*POINT_SIZE, 4*POINT_SIZE, 
						mdc,NEXT_X,NEXT_Y,SRCCOPY);
			

			SelectObject(mdc,old_bmp);

			DeleteDC(mdc);
			DeleteObject(bmp);
			ReleaseDC(hw,dc);
		}
		return 0;
	case WM_KEYDOWN:
		{
			switch(wp) 
			{
			case VK_LEFT: 
				{
					StepLeft();
				}
				break;
			case VK_RIGHT: 
				{
					StepRight();
				}
				break;
			case VK_SPACE: 
				{
					StepRotate();
				}
				break;
			case VK_DOWN: 
				{
					StepDown();
				}
				break;
			case 80:// p
				{
					SetPause();
				}
				break;
			case VK_ESCAPE: g_run=false; break;
			default: ;// ATLTRACE(_T("WM_KEYDOWN\n"));
			}
		}
		break;
	case WM_CLOSE: g_run=false; break;
	default:;
	}

	return DefWindowProc(hw,m,wp,lp);
}

void	RegisterWindowCalss()
{
	WNDCLASS	class_params;
	ATOM		window_class;

	class_params.lpfnWndProc=WindowProc; 
	class_params.style=CS_HREDRAW|CS_VREDRAW|CS_OWNDC;
	class_params.cbClsExtra=0; 
	class_params.cbWndExtra=0; 
	class_params.hInstance=NULL; 
	class_params.hIcon=NULL; 
	class_params.hCursor=LoadCursor( NULL, IDC_ARROW );
	class_params.hbrBackground=(HBRUSH)( COLOR_WINDOW );//NULL;//
	class_params.lpszMenuName=NULL; 
	class_params.lpszClassName=window_class_name; 

	window_class=RegisterClass(&class_params);
}


void InitWindow()
{
	RegisterWindowCalss();
	window_main=CreateWindowEx(WS_EX_APPWINDOW,window_class_name,NULL,WS_SYSMENU|WS_VISIBLE/*|WS_SIZEBOX*/,
		0,0,200,250,NULL,NULL,NULL,NULL);
	SetWindowText(window_main,_T("Tetris"));


	CreateWindow( _T("STATIC"), _T("speed 10"),SS_LEFT|WS_VISIBLE|WS_CHILD,
								INFO_X,INFO_Y, 80,15,window_main,NULL,NULL,NULL);
	CreateWindow( _T("STATIC"), _T("level 10"),SS_LEFT|WS_VISIBLE|WS_CHILD, 
								INFO_X,INFO_Y+20, 80,15,window_main,NULL,NULL,NULL);
	CreateWindow( _T("STATIC"), _T("next"),SS_LEFT|WS_VISIBLE|WS_CHILD, 
								INFO_X,NEXT_Y-20, 80,15,window_main,NULL,NULL,NULL);
	window_pause=CreateWindow( _T("STATIC"), _T("pause"),SS_LEFT/*|WS_VISIBLE*/|WS_CHILD, 
								INFO_X,INFO_Y+40, 80,15,window_main,NULL,NULL,NULL);
	CreateWindow( _T("STATIC"), _T("rotate"),SS_LEFT|WS_VISIBLE|WS_CHILD, 
								INFO_X,INFO_Y+60, 80,15,window_main,NULL,NULL,NULL);
	window_score=CreateWindow( _T("STATIC"), _T("score 0"),SS_LEFT|WS_VISIBLE|WS_CHILD, 
								INFO_X,0, 80,15,window_main,NULL,NULL,NULL);
}

void UninitWindow()
{
	DestroyWindow(window_main);
	UnregisterClass(window_class_name, NULL);
}

int WINAPI WinMain(
				   HINSTANCE hInstance,      // handle to current instance
				   HINSTANCE hPrevInstance,  // handle to previous instance
				   LPSTR lpCmdLine,          // command line
				   int nCmdShow              // show state
				   )
{
	MSG					msg;

	DropFigure();
	InitWindow();
	::SetTimer(window_main,TIMER_ID_STEP,timet_interval_step,TimerStepProc);

	while(g_run)
	{
		MsgWaitForMultipleObjects(0,NULL,FALSE,INFINITE,QS_ALLEVENTS);
		while(PeekMessage(&msg, window_main, 0, 0,PM_REMOVE)) 
			DispatchMessage(&msg);
	}

	KillTimer(NULL,0);
	UninitWindow();

	return 0;
}

